; config.inc
;
; Robert stling 2002-05-02


; ----- Driver ID:s --------------------
;
; Don't mess too much with these... :)

%define driver_id_serial		0x1000
%define driver_id_kbd			0x1001
%define driver_id_screen		0x1002

; --------------------------------------



; ----- serial.asm ---------------------

%define serial_default_baudrate		serial_baud_2400
%define serial_default_stopbit		serial_stopbit_1
%define serial_default_wordlength	serial_wordlength_8
%define serial_default_partity		serial_partity_none

%define serial_buffer_size		0x1000		; 4kB per port... maybe we should increase this?

; --------------------------------------



; ----- mem.asm ------------------------

%define mem_default_high_start	0x00120000	; 128KB after kernel start.
%define mem_default_high_end	0x00400000	; Assume 4MB of memory.

; Note: No low memory can be allocated by default, it's used for DMA transfers.

%define mem_default_low_start	0x00001000	; Staring at 0x1000 (segment 0x100)
%define mem_default_low_end	0x00080000	; Up to 512K

%define mem_default_table_size	0x4000		; 16K entries should be enough...

; --------------------------------------



; ----- pipe.asm -----------------------

%define pipe_blocksize		0x1000			; 4kB blocks should be enough.

; --------------------------------------


; ----- kbd.asm ------------------------

%define kbd_max_devices		0x8			; 8 virtual keyboards
%define kbd_default_map		keymap_se

; --------------------------------------


; ----- screen.asm ---------------------

%define screen_default_screens	0x8			; 8 virtual screens

; --------------------------------------
