; proc.inc
;
; Robert stling, 2002-02-03

%ifndef _proc_asm

extern	proc_current
extern	proc_registers
extern	proc_mt
extern	proc_switch

extern	proc_init
extern	proc_create
extern	proc_kill
extern	proc_get_pointer
extern	proc_get_current_pid
extern	proc_get_current_stdin
extern	proc_get_current_stdout
extern	proc_get_current_info

%endif


%define SIZE_REGISTERS	152

%define PROC_RUNNING	0
%define PROC_SLEEPING	1
%define proc_running	0
%define proc_sleeping	1


	struc proc_struct
.registers	resb	SIZE_REGISTERS		; size of all the registers (152)
.next		resd	1			; pointer to next proc_struct
.prev		resd	1			; pointer to previous proc_struct
.stack		resd	1			; points to the stack, has to be freed!
.info		resd	1			; pointer to process info struct
.status		resb	1			; PROC_RUNNING / PROC_SLEEPING
.nosave		resb	1			; flag that tells us if we should save registers
.id		resd	1			; PID
	endstruc

	struc proc_info
.uid		resw	1			; user ID of process
.ipc_list	resd	1			; pointer to list of IPC messages
.stdin		resd	1			; standard input
.stdout		resd	1			; standard output
	endstruc
