; serial.inc
;
; Robert stling 2002-05-01

%define serial_baud_115200	0x01
%define serial_baud_57600	0x02
%define serial_baud_38400	0x03
%define serial_baud_19200	0x06
%define serial_baud_9600	0x0c
%define serial_baud_4800	0x18
%define serial_baud_2400	0x30
%define serial_baud_1800	0x40
%define serial_baud_1200	0x60
%define serial_baud_600		0xc0
%define serial_baud_300		0x180
%define serial_baud_150		0x300
%define serial_baud_75		0x600
%define serial_baud_50		0x900

%define serial_stopbit_1	0x00
%define serial_stopbit_2	0x04

%define serial_wordlength_5	0x00
%define serial_wordlength_6	0x01
%define serial_wordlength_7	0x02
%define serial_wordlength_8	0x03

%define serial_partity_none	0x00
%define serial_partity_odd	0x08
%define serial_partity_even	0x18
%define serial_partity_high	0x28
%define serial_partity_low	0x38

%define serial_port		0x00
%define serial_ier		0x01
%define serial_iir		0x02
%define serial_lcr		0x03
%define serial_mcr		0x04
%define serial_lsr		0x05
%define serial_msr		0x06
%define serial_scr		0x07



	struc serial_config
.baudrate	resw	1
.stopbit	resb	1
.wordlength	resb	1
.partity	resb	1
.dummy		resb	3		; serial_config_size = 8
	endstruc

%if serial_config_size != 8
%error serial_config_size != 8
%endif


%ifndef _serial_asm

extern serial_chardev_init
extern serial_chardev_open
extern serial_chardev_close
extern serial_chardev_read
extern serial_chardev_write
extern serial_chardev_options

%endif
